import numpy as np
import pandas as pd
from plaster.run.base_result import ArrayResult, BaseResult
from plaster.run.rad_filter.rad_filter_params import RadFilterParams
from plaster.tools.log.log import debug


class RadFilterResult(BaseResult):
    name = "rad_filter"
    filename = "rad_filter.pkl"

    required_props = dict(
        params=RadFilterParams,
        field_df=pd.DataFrame,
        field_align_thresh=int,
        per_peak_df=pd.DataFrame,
        ch_peak_df=pd.DataFrame,
        noi_thresh_per_ch=np.ndarray,
        filter_df=pd.DataFrame,
    )

    def __repr__(self):
        return "RadFilterResult"
