import pudb
import sys
import numpy as np
from plaster.tools.zlog.zlog import spy, add_log_fields
from logging import getLogger

log = getLogger(__name__)


def normal_traces():
    log.debug("example_module.py wrote to root logger.debug")
    print("example_module.py wrote to stdout")
    print("example_module.py wrote to stderr", file=sys.stderr)


def spies_int():
    a = 1
    spy(a, b=a + 1)


def spies_array():
    a = np.array([1, 2])
    spy(a)


def spies_mixed():
    a_var = "but"
    spy(a_var, "why?!", 345, (1, 2, 3), hello="world")


def raises_an_exception():
    raise Exception("test exception")


def run_pudb():
    # Used to demonstrate what happens when a pudb set_trace
    # is called in a headless environment.
    # This is testing the common failure mode where a set_trace
    # gets left in some deployed headless code.
    pudb.set_trace()


def add_new_field():
    with add_log_fields(bar="123"):
        log.debug("should contain new field")
